<!DOCTYPE html>
<html>
<head>
<meta charset="UTF-8">
<title>documentation/info_segments/heap_manager_.info</title>
<meta name="Generator" content="Vim/9.1">
<meta name="plugin-version" content="vim9.0_v2">
<meta name="syntax" content="none">
<meta name="settings" content="number_lines,use_css,no_foldcolumn,expand_tabs,line_ids,pre_wrap,prevent_copy=,use_input_for_pc=none">
<meta name="colorscheme" content="PaperColor">
<style>
<!--
pre { white-space: pre-wrap; font-family: monospace; color: #d0d0d0; background-color: #000000; }
body { font-family: monospace; color: #d0d0d0; background-color: #000000; }
* { font-size: 1em; }
.textRainbow_lv1_p0 { color: #ffffe0; }
.textRainbow_lv0_o0 { color: #add8e6; }
.textRainbow_lv0_p0 { color: #add8e6; }
.LineNr { color: #585858; }
-->
</style>

<script>
<!--

/* function to open any folds containing a jumped-to line before jumping to it */
function JumpToLine()
{
  var lineNum;
  lineNum = window.location.hash;
  lineNum = lineNum.substr(1); /* strip off '#' */

  if (lineNum.indexOf('L') == -1) {
    lineNum = 'L'+lineNum;
  }
  var lineElem = document.getElementById(lineNum);
  /* Always jump to new location even if the line was hidden inside a fold, or
   * we corrected the raw number to a line ID.
   */
  if (lineElem) {
    lineElem.scrollIntoView(true);
  }
  return true;
}
if ('onhashchange' in window) {
  window.onhashchange = JumpToLine;
}

-->
</script>
</head>
<body onload='JumpToLine();'>
<pre id='vimCodeElement'>
<span id="L1" class="LineNr">  1 </span>03/17/86  heap_manager_
<span id="L2" class="LineNr">  2 </span>
<span id="L3" class="LineNr">  3 </span>
<span id="L4" class="LineNr">  4 </span>To obtain information on a particular entry point use the &quot;ep&quot; request
<span id="L5" class="LineNr">  5 </span>
<span id="L6" class="LineNr">  6 </span>
<span id="L7" class="LineNr">  7 </span>Entry points in heap_manager_:
<span id="L8" class="LineNr">  8 </span>   <span class="textRainbow_lv0_p0">(</span>List is generated by the help command<span class="textRainbow_lv0_p0">)</span>
<span id="L9" class="LineNr">  9 </span>
<span id="L10" class="LineNr"> 10 </span>
<span id="L11" class="LineNr"> 11 </span>:Entry:  push_heap_level: 03/17/86  heap_manager_$push_heap_level
<span id="L12" class="LineNr"> 12 </span>
<span id="L13" class="LineNr"> 13 </span>
<span id="L14" class="LineNr"> 14 </span>Function: This entry point creates a new heap level, allocates
<span id="L15" class="LineNr"> 15 </span>the heap header and chains the previous heap to the current
<span id="L16" class="LineNr"> 16 </span>heap. If the stack_header_ptr is null an error of
<span id="L17" class="LineNr"> 17 </span>error_table_$null_info_ptr is returned.
<span id="L18" class="LineNr"> 18 </span>
<span id="L19" class="LineNr"> 19 </span>
<span id="L20" class="LineNr"> 20 </span>Syntax:
<span id="L21" class="LineNr"> 21 </span>declare heap_manager_$push_heap_level entry <span class="textRainbow_lv0_p0">(</span>pointer<span class="textRainbow_lv0_o0">,</span> fixed
<span id="L22" class="LineNr"> 22 </span>  bin<span class="textRainbow_lv1_p0">(</span>17<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span> fixed bin<span class="textRainbow_lv1_p0">(</span>35<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_p0">)</span>;
<span id="L23" class="LineNr"> 23 </span>call heap_manager_$push_heap_level <span class="textRainbow_lv0_p0">(</span>stack_header_ptr<span class="textRainbow_lv0_o0">,</span> exe_level<span class="textRainbow_lv0_o0">,</span>
<span id="L24" class="LineNr"> 24 </span>  code<span class="textRainbow_lv0_p0">)</span>;
<span id="L25" class="LineNr"> 25 </span>
<span id="L26" class="LineNr"> 26 </span>
<span id="L27" class="LineNr"> 27 </span>Arguments:
<span id="L28" class="LineNr"> 28 </span>stack_header_ptr
<span id="L29" class="LineNr"> 29 </span>   is a pointer to the stack header.  This can be obtained via
<span id="L30" class="LineNr"> 30 </span>   the PL/1 builtin stackbaseptr<span class="textRainbow_lv0_p0">()</span>.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L31" class="LineNr"> 31 </span>exe_level
<span id="L32" class="LineNr"> 32 </span>   is the new execution level after the new heap is created.
<span id="L33" class="LineNr"> 33 </span>   <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L34" class="LineNr"> 34 </span>code
<span id="L35" class="LineNr"> 35 </span>   is a standard status code.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L36" class="LineNr"> 36 </span>
<span id="L37" class="LineNr"> 37 </span>
<span id="L38" class="LineNr"> 38 </span>:Entry:  pop_heap_level: 03/17/86  heap_manager_$pop_heap_level
<span id="L39" class="LineNr"> 39 </span>
<span id="L40" class="LineNr"> 40 </span>
<span id="L41" class="LineNr"> 41 </span>Function: This entry point resets the heap to the previous level
<span id="L42" class="LineNr"> 42 </span>freeing the old heap and any variables allocated therein.
<span id="L43" class="LineNr"> 43 </span>
<span id="L44" class="LineNr"> 44 </span>
<span id="L45" class="LineNr"> 45 </span>Syntax:
<span id="L46" class="LineNr"> 46 </span>declare heap_manager_$pop_heap_level entry <span class="textRainbow_lv0_p0">(</span>pointer<span class="textRainbow_lv0_o0">,</span> fixed
<span id="L47" class="LineNr"> 47 </span>  bin<span class="textRainbow_lv1_p0">(</span>35<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_p0">)</span>;
<span id="L48" class="LineNr"> 48 </span>call heap_manager_$pop_heap_level <span class="textRainbow_lv0_p0">(</span>stack_header_ptr<span class="textRainbow_lv0_o0">,</span> code<span class="textRainbow_lv0_p0">)</span>;
<span id="L49" class="LineNr"> 49 </span>
<span id="L50" class="LineNr"> 50 </span>
<span id="L51" class="LineNr"> 51 </span>Arguments:
<span id="L52" class="LineNr"> 52 </span>stack_header_ptr
<span id="L53" class="LineNr"> 53 </span>   is a pointer to the stack header.  This can be obtained via
<span id="L54" class="LineNr"> 54 </span>   the PL/1 builtin stackbaseptr<span class="textRainbow_lv0_p0">()</span>.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L55" class="LineNr"> 55 </span>code
<span id="L56" class="LineNr"> 56 </span>   is a standard status code.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L57" class="LineNr"> 57 </span>
<span id="L58" class="LineNr"> 58 </span>
<span id="L59" class="LineNr"> 59 </span>:Entry:  get_heap_header: 03/17/86  heap_manager_$get_heap_header
<span id="L60" class="LineNr"> 60 </span>
<span id="L61" class="LineNr"> 61 </span>
<span id="L62" class="LineNr"> 62 </span>Function: This entry point returns a pointer to the heap header
<span id="L63" class="LineNr"> 63 </span>for the specified execution level.  If the execution level does
<span id="L64" class="LineNr"> 64 </span>not exist an error of error_table_$no_heap_defined is returned.
<span id="L65" class="LineNr"> 65 </span>
<span id="L66" class="LineNr"> 66 </span>
<span id="L67" class="LineNr"> 67 </span>Syntax:
<span id="L68" class="LineNr"> 68 </span>declare heap_manager_$get_heap_header entry <span class="textRainbow_lv0_p0">(</span>pointer<span class="textRainbow_lv0_o0">,</span> fixed
<span id="L69" class="LineNr"> 69 </span>  bin<span class="textRainbow_lv1_p0">(</span>17<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span> pointer<span class="textRainbow_lv0_o0">,</span> fixed bin<span class="textRainbow_lv1_p0">(</span>35<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_p0">)</span>;
<span id="L70" class="LineNr"> 70 </span>call heap_manager_$get_heap_header <span class="textRainbow_lv0_p0">(</span>stack_header_ptr<span class="textRainbow_lv0_o0">,</span> exe_level<span class="textRainbow_lv0_o0">,</span>
<span id="L71" class="LineNr"> 71 </span>  heap_header_ptr<span class="textRainbow_lv0_o0">,</span> code<span class="textRainbow_lv0_p0">)</span>;
<span id="L72" class="LineNr"> 72 </span>
<span id="L73" class="LineNr"> 73 </span>
<span id="L74" class="LineNr"> 74 </span>Arguments:
<span id="L75" class="LineNr"> 75 </span>exe_level
<span id="L76" class="LineNr"> 76 </span>   is the execution level of the heap required. If a -1 is passed
<span id="L77" class="LineNr"> 77 </span>   then the current execution level is used.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L78" class="LineNr"> 78 </span>stack_header_ptr
<span id="L79" class="LineNr"> 79 </span>   is a pointer to the stack header.  This can be obtained via
<span id="L80" class="LineNr"> 80 </span>   the PL/1 builtin stackbaseptr<span class="textRainbow_lv0_p0">()</span>.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L81" class="LineNr"> 81 </span>heap_header_ptr
<span id="L82" class="LineNr"> 82 </span>   is a pointer to the heap header for the passed execution
<span id="L83" class="LineNr"> 83 </span>   level. <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>.
<span id="L84" class="LineNr"> 84 </span>code
<span id="L85" class="LineNr"> 85 </span>   is a standard status code.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L86" class="LineNr"> 86 </span>
<span id="L87" class="LineNr"> 87 </span>
<span id="L88" class="LineNr"> 88 </span>:Entry:  get_heap_level: 03/17/86  heap_manager_$get_heap_level
<span id="L89" class="LineNr"> 89 </span>
<span id="L90" class="LineNr"> 90 </span>
<span id="L91" class="LineNr"> 91 </span>Function: This entry point returns the current execution level
<span id="L92" class="LineNr"> 92 </span>from the current heap header.  If the heap does not exist an execution
<span id="L93" class="LineNr"> 93 </span>level of -1 is returned.
<span id="L94" class="LineNr"> 94 </span>
<span id="L95" class="LineNr"> 95 </span>
<span id="L96" class="LineNr"> 96 </span>Syntax:
<span id="L97" class="LineNr"> 97 </span>declare heap_manager_$get_heap_level entry <span class="textRainbow_lv0_p0">(</span>pointer<span class="textRainbow_lv0_p0">)</span>
<span id="L98" class="LineNr"> 98 </span>  returns <span class="textRainbow_lv0_p0">(</span>fixed bin<span class="textRainbow_lv1_p0">(</span>17<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_p0">)</span>;
<span id="L99" class="LineNr"> 99 </span>exe_level =  heap_manager_$get_heap_level <span class="textRainbow_lv0_p0">(</span>stack_header_ptr<span class="textRainbow_lv0_p0">)</span>;
<span id="L100" class="LineNr">100 </span>
<span id="L101" class="LineNr">101 </span>
<span id="L102" class="LineNr">102 </span>Arguments:
<span id="L103" class="LineNr">103 </span>stack_header_ptr
<span id="L104" class="LineNr">104 </span>   is a pointer to the stack header.  This can be obtained via
<span id="L105" class="LineNr">105 </span>   the PL/1 builtin stackbaseptr<span class="textRainbow_lv0_p0">()</span>.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L106" class="LineNr">106 </span>
<span id="L107" class="LineNr">107 </span>
<span id="L108" class="LineNr">108 </span>:Entry:  get_heap_area: 03/17/86  heap_manager_$get_heap_area
<span id="L109" class="LineNr">109 </span>
<span id="L110" class="LineNr">110 </span>
<span id="L111" class="LineNr">111 </span>Function: This entry point returns a pointer to the heap area
<span id="L112" class="LineNr">112 </span>for the specified level.  The area is max_segsize - 50 words.
<span id="L113" class="LineNr">113 </span>If the heap level specified does not exist an error of
<span id="L114" class="LineNr">114 </span>error_table_$no_heap_defined is returned.
<span id="L115" class="LineNr">115 </span>
<span id="L116" class="LineNr">116 </span>
<span id="L117" class="LineNr">117 </span>Syntax:
<span id="L118" class="LineNr">118 </span>declare heap_manager_$get_heap_area entry <span class="textRainbow_lv0_p0">(</span>pointer<span class="textRainbow_lv0_o0">,</span> fixed
<span id="L119" class="LineNr">119 </span>  bin<span class="textRainbow_lv1_p0">(</span>17<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span> pointer<span class="textRainbow_lv0_o0">,</span> fixed bin<span class="textRainbow_lv1_p0">(</span>35<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_p0">)</span>;
<span id="L120" class="LineNr">120 </span>call heap_manager_$get_heap_area <span class="textRainbow_lv0_p0">(</span>stack_header_ptr<span class="textRainbow_lv0_o0">,</span> exe_level<span class="textRainbow_lv0_o0">,</span>
<span id="L121" class="LineNr">121 </span>  heap_area_ptr<span class="textRainbow_lv0_o0">,</span> code<span class="textRainbow_lv0_p0">)</span>;
<span id="L122" class="LineNr">122 </span>
<span id="L123" class="LineNr">123 </span>
<span id="L124" class="LineNr">124 </span>Arguments:
<span id="L125" class="LineNr">125 </span>exe_level
<span id="L126" class="LineNr">126 </span>   is the execution level of the heap area required. If a -1 is
<span id="L127" class="LineNr">127 </span>   passed then the current execution level is used.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L128" class="LineNr">128 </span>stack_header_ptr
<span id="L129" class="LineNr">129 </span>   is a pointer to the stack header.  This can be obtained via
<span id="L130" class="LineNr">130 </span>   the PL/1 builtin stackbaseptr<span class="textRainbow_lv0_p0">()</span>.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L131" class="LineNr">131 </span>heap_area_ptr
<span id="L132" class="LineNr">132 </span>   is pointer to the heap area for the passed level. <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L133" class="LineNr">133 </span>code
<span id="L134" class="LineNr">134 </span>   is a standard status code.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L135" class="LineNr">135 </span>
</pre>
<script defer src='https://static.cloudflareinsights.com/beacon.min.js' data-cf-beacon='{"token": "4b6a131644014aa29fd88953508c3a3d"}'></script></body>
</html>
<!-- vim: set foldmethod=manual : -->
